#!/bin/bash

#-x для отладки убрать знак # и перенеси на строку выше

#Скрипт установки пакета chai
#Меню установки -----------------------------------------------------------
PS3="Введите вариант установки Chai:"
echo -e "Возможные варианты установки Chai:"
select PRJ1 in Lib Libtest Full Test_Prog Help Quit; do


	case $PRJ1 in

		Lib)
   	 		export PROJECT='Lib'	
   	 		break
   	 		;;
	
		Libtest)
    		export PROJECT='Libtest'
    		break
    		;;

		Full)
   			export PROJECT='Full'
			break
    		;;
		Test_Prog)
   			export PROJECT='Test_Prog'
			break
    		;;	
    	Help)
   			echo -e "Lib-инсталяция библиотеки libchai\nLibtest-инсталяция библиотеки libchai и программы chaitest\nFull-устновка библиотеки chai программ chaitest и canmon"
    		;;
  		Quit)
   			export PROJECT='Quit'
   			exit 0
			;;
  		*)
    		echo -e "Нет такой команды"
    		;;
 	esac
done
#----------------------------------------------------------
echo -e "Вариант установки: $PROJECT"
#----------------------------------------------------------
#Проверка наличия cmake и установка (требуемой версии!!!!!)-------
cmake --version
sudo apt-get install -y cmake 
sudo apt-get update && sudo apt-get install -y build-essential
cmake --version
#-------------------------------------------
#Устанвока драйвера FTDI-----------------------------------
cd chai/lib
cp libftd2xx.* /usr/local/lib
chmod 0755 /usr/local/lib/libftd2xx.so.1.4.8
ln -sf /usr/local/lib/libftd2xx.so.1.4.8 /usr/local/lib/libftd2xx.so
cd ..
cd include/
cp ftd2xx.h  /usr/local/include
cp WinTypes.h  /usr/local/include
ldconfig
ldconfig -p | grep libftd2xx
cd ..
#-------------------------------------------
#---------Запуск сборки выбранного проекта-------------------------------------------------
	case $PROJECT in

			Lib)
#				echo $PWD ----- для отладки дирректорий
				cd include/
				cp chai.h /usr/local/include
				cp chai-cbunp.h /usr/local/include
				cp chai-lnx.h /usr/local/include
				cp sja1000.h /usr/local/include
				cp sysdep.h /usr/local/include
				cp unican.h /usr/local/include
				cd ..
				rm -f chai/lib/libchai.so
				mkdir -p build_lib
				cd build_lib
				cmake -DCMAKE_BUILD_TYPE=Debug ../build_lib ../chai_lib
				make
				cd ..
				cp build_lib/libchai.so ../chai/lib/
				cp build_lib/libchai.so /usr/local/lib
				chmod 0755 /usr/local/lib/libchai.so
				ldconfig
				ldconfig -p | grep libchai.so
				rm -rf build_lib/
				echo -e "Библиотека подключена исходный файл =>: $PWD/lib "
				;;
			Libtest)
				cd include/
				cp chai.h /usr/local/include
				cp chai-cbunp.h /usr/local/include
				cp chai-lnx.h /usr/local/include
				cp sja1000.h /usr/local/include
				cp sysdep.h /usr/local/include
				cp unican.h /usr/local/include
				cd ..
				rm -f chai/lib/libchai.so
				mkdir -p build_lib
				cd build_lib
				cmake -DCMAKE_BUILD_TYPE=Debug ../build_lib ../chai_lib
				make
				cd ..
				cp build_lib/libchai.so ../chai/lib/
				cp build_lib/libchai.so /usr/local/lib
				chmod 0755 /usr/local/lib/libchai.so
				ldconfig
				ldconfig -p | grep libchai.so
				rm -rf build_lib/
				echo -e "Библиотека подключена исходный файл =>: $PWD/lib "
				mkdir -p build_chaitest
				cd build_chaitest
				cmake -DCMAKE_BUILD_TYPE=Debug ../build_chaitest ../chai_test
				make
				cd ..
				mkdir -p bin_chaitest
				echo $PWD
				cp build_chaitest/chaitest ../chai/bin_chaitest/
				rm -rf build_chaitest
				echo -e "Chaitest готов исполняемый файл =>: $PWD/bin_chaitest "
				;;
			Full)
				cd include/
				cp chai.h /usr/local/include
				cp chai-cbunp.h /usr/local/include
				cp chai-lnx.h /usr/local/include
				cp sja1000.h /usr/local/include
				cp sysdep.h /usr/local/include
				cp unican.h /usr/local/include
				cd ..
				rm -f chai/lib/libchai.so
				mkdir -p build_lib
				cd build_lib
				cmake -DCMAKE_BUILD_TYPE=Debug ../build_lib ../chai_lib
				make
				cd ..
				cp build_lib/libchai.so ../chai/lib/
				cp build_lib/libchai.so /usr/local/lib
				chmod 0755 /usr/local/lib/libchai.so
				ldconfig
				ldconfig -p | grep libchai.so
				rm -rf build_lib/
				echo -e "Библиотека подключена исходный файл =>: $PWD/lib "
				mkdir -p build_canmon
				cd build_canmon
				cmake -DCMAKE_BUILD_TYPE=Debug ../build_canmon ../can_mon
				make
				cd ..
				mkdir -p bin_canmon
				echo $PWD
				cp build_canmon/canmon ../chai/bin_canmon/
				rm -rf build_canmon
				echo -e "canmon готов исполняемый файл =>: $PWD/bin_canmon "
				;;
			Test_Prog)	
				cd include/
				cp chai.h /usr/local/include
				cp chai-cbunp.h /usr/local/include
				cp chai-lnx.h /usr/local/include
				cp sja1000.h /usr/local/include
				cp sysdep.h /usr/local/include
				cp unican.h /usr/local/include
				cd ..
				rm -f chai/lib/libchai.so
				mkdir -p build_lib
				cd build_lib
				cmake -DCMAKE_BUILD_TYPE=Debug ../build_lib ../chai_lib
				make
				cd ..
				cp build_lib/libchai.so ../chai/lib/
				cp build_lib/libchai.so /usr/local/lib
				chmod 0755 /usr/local/lib/libchai.so
				ldconfig
				ldconfig -p | grep libchai.so
				rm -rf build_lib/
				echo -e "Библиотека подключена исходный файл =>: $PWD/lib "
				mkdir -p build_writer
				cd build_writer
				cmake -DCMAKE_BUILD_TYPE=Debug ../build_writer ../writer
				make
				cd ..
				mkdir -p bin_writer
				echo $PWD
				cp build_writer/writer ../chai/bin_writer/
				rm -rf build_writer
				echo -e "writer готов исполняемый файл =>: $PWD/bin_writer "
				;;
	esac
echo -e "Установка завершена"
#-------------------------------------------
